"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const isFunction_1 = __importDefault(require("../isFunction"));
const isObject_1 = __importDefault(require("../isObject"));
const isString_1 = __importDefault(require("../isString"));
function getFindPredicate(predicate) {
    switch (true) {
        case isFunction_1.default(predicate):
            return predicate;
        case isObject_1.default(predicate):
            return (item) => {
                let index = -1;
                const keys = Object.keys(predicate);
                const length = keys.length;
                while (++index < length) {
                    const key = keys[index];
                    if (!item[key] || item[key] !== predicate[key]) {
                        return false;
                    }
                }
                return true;
            };
        case isString_1.default(predicate):
            return (item) => {
                if (item[predicate] === true) {
                    return true;
                }
                return false;
            };
        default:
            return predicate;
    }
}
exports.default = getFindPredicate;
//# sourceMappingURL=getFilterPredicate.js.map