"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const map_1 = __importDefault(require("../map"));
const find_1 = __importDefault(require("../find"));
const filter_1 = __importDefault(require("../filter"));
const reject_1 = __importDefault(require("../reject"));
const castArray_1 = __importDefault(require("../castArray"));
class ChainWrapper {
    constructor(value) {
        this.castArray = () => {
            this._chainedFunctions.push({
                operation: castArray_1.default
            });
            return this;
        };
        this.map = (func) => {
            this._chainedFunctions.push({
                operation: map_1.default,
                func
            });
            return this;
        };
        this.filter = (func) => {
            this._chainedFunctions.push({
                operation: filter_1.default,
                func
            });
            return this;
        };
        this.find = (func) => {
            this._chainedFunctions.push({
                operation: find_1.default,
                func
            });
            return this;
        };
        this.reject = (func) => {
            this._chainedFunctions.push({
                operation: reject_1.default,
                func
            });
            return this;
        };
        this.value = () => {
            let index = -1;
            const length = this._chainedFunctions.length;
            while (++index < length) {
                const chainedFunctions = this._chainedFunctions[index];
                this._value = chainedFunctions.operation(this._value, chainedFunctions.func);
            }
            return this._value;
        };
        this._value = value;
        this._chainedFunctions = [];
    }
}
function chain(value) {
    return new ChainWrapper(value);
}
exports.default = chain;
//# sourceMappingURL=index.js.map