"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const _1 = __importDefault(require("."));
describe("Map", () => {
    const array = [1, 2];
    it("should map values in collection to a new array", () => {
        const object = {
            a: 1,
            b: 2
        };
        const expected = ["1", "2"];
        chai_1.expect(_1.default(array, String)).to.eql(expected);
        chai_1.expect(_1.default(object, String)).to.eql(expected);
    });
    it("should work with string shorthands", () => {
        const objects = [
            {
                a: "x"
            },
            {
                a: "y"
            }
        ];
        const result = _1.default(objects, "a");
        chai_1.expect(result).to.eql(["x", "y"]);
    });
});
//# sourceMappingURL=map.spec.js.map